﻿package com{
	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.display.Shape;
	import flash.display.Graphics;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Rectangle;

	public class MeasuringAngles extends MovieClip {

		var myStage:MovieClip;
		var myAngle=0;
		var curveMc:Shape=new Shape();
		var rad:Number=40;
		var PI=(Math.PI/180);
		var correctAngTxt=0;
		var angCor=0;
		var txtCor=0;
		var angTxtArr:Array=["acute angle","right angle","obtuse angle","straight (flat) angle","reflex angle"];
		
		var sw:Number=760;
		var sh:Number=430;

		public function MeasuringAngles() {
			myStage=this;			
			protractor_mc.xpos=protractor_mc.x;
			protractor_mc.ypos=protractor_mc.y;
			randomAngle();
			init();

		}
		private function randomAngle() {
			myAngle=Math.floor(Math.random()*360);
			if ((myAngle%5)!=0) {
				var multiplier=Math.round(myAngle/5);
				myAngle=multiplier*5;
			}
			//trace("myAngle = "+myAngle);
			//myAngle=90;
			arrowLine.rotation=(360-myAngle);
			if (myAngle==360) {
				myAngle=0;
			}
			if (myAngle>180) {
				protractor_mc.gotoAndStop(2);
			} else {
				protractor_mc.gotoAndStop(1);
			}
			drawCurve();

		}
		private function drawCurve() {
			curveMc.graphics.clear();
			curveMc.graphics.lineStyle(2,0x0D3D6A,1);
			curveMc.graphics.moveTo(arrowLine.x, arrowLine.y);
			if (myAngle==90) {
				curveMc.graphics.lineTo(arrowLine.x+rad, arrowLine.y);
				curveMc.graphics.lineTo(arrowLine.x+rad, arrowLine.y-rad);
				curveMc.graphics.lineTo(arrowLine.x, arrowLine.y-rad);
				curveMc.graphics.lineTo(arrowLine.x, arrowLine.y);
			} else {
				for (var i=0; i<=myAngle; i++) {
					var ang =  360-i;
					var xMov = arrowLine.x+Math.cos(ang*PI)*rad;
					var yMov = arrowLine.y+Math.sin(ang*PI)*rad;
					//trace(xMov+"--"+yMov);
					//curveMc.graphics.moveTo(arrowLine.x, arrowLine.y);
					curveMc.graphics.lineTo(xMov, yMov);
				}
			}
		}
		private function init() {
			curveMc.graphics.lineStyle(2,0x0D3D6A,1);
			myStage.addChild(curveMc);
			myStage.setChildIndex(arrow2, myStage.numChildren-1);
			myStage.setChildIndex(arrowLine, myStage.numChildren-1);
			arrowLine.addEventListener(MouseEvent.MOUSE_DOWN, onDownArrow);
			arrowLine.addEventListener(MouseEvent.MOUSE_UP, onUpArrow);
			for (var i=1; i<=5; i++) {
				myStage["angTxt"+i].num=i;
				myStage["angTxt" + i].buttonMode=true;
				myStage["angTxt" + i].addEventListener(MouseEvent.CLICK, showTxtFeedback);
			}
			reset_btn.addEventListener(MouseEvent.CLICK, resetActivity);
			tick_mc1.visible=false;
			tick_mc2.visible=false;
			feedback_mc.visible=false;
			/*myStage.stage.focus=myTxt;*/
			protractor_mc.addEventListener(MouseEvent.MOUSE_DOWN, onDragPro);
			protractor_mc.addEventListener(MouseEvent.MOUSE_UP, onDropPro);
			myTxt.restrict="0-9";
			myTxt.addEventListener(Event.CHANGE, onInputChange);
		}
		private function onInputChange(evt:Event) {
			if (String(myTxt.text).indexOf("°")==-1) {
				myTxt.appendText("°");
			}else{
				var myStr:String=myTxt.text;
				var myArr=myStr.split("°");
				myStr=myArr.join("");
				myTxt.text=myStr+"°";
				/*var myInd=myStr.indexOf("°");
				trace("myInd = "+myInd);
				myTxt.text=myStr.slice(myInd,1)+"°";
				trace("myStr = "+myStr);*/
			}
			myStr=myTxt.text;
			myArr=myStr.split("°");
			myStr=myArr.join("");
			tick_mc1.visible=true;
			if(Number(myStr)==myAngle){
				angCor=1;				
				tick_mc1.gotoAndStop(1);
			}else{
				angCor=0;
				//tick_mc1.visible=false;
				tick_mc1.gotoAndStop(2);
			}
			checkAnswers();
		}
		private function onDragPro(evt:MouseEvent) {
			protractor_mc.startDrag(false, new Rectangle(protractor_mc.width/2, protractor_mc.height/2, sw-protractor_mc.width, sh-protractor_mc.height));
			//protractor_mc.parent.setChildIndex(protractor_mc, protractor_mc.parent.numChildren-1);
			protractor_mc.parent.stage.addEventListener(MouseEvent.MOUSE_UP, onDropPro);
		}
		private function onDropPro(evt:MouseEvent) {
			protractor_mc.stopDrag();
			protractor_mc.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, onDropPro);
			var myTar=protractor_mc.dropTarget;
			if (myTar!=null) {
				//trace(myTar.name);
				if (myTar.parent.name=="base_mc") {
					protractor_mc.x=arrowLine.x;
					protractor_mc.y=arrowLine.y;
				}
			}
		}
		private function resetActivity(evt:MouseEvent) {
			protractor_mc.x=protractor_mc.xpos;
			protractor_mc.y=protractor_mc.ypos;
			resetAngTxt();
			randomAngle();
			angCor=0;
			txtCor=0;
			feedback_mc.visible=false;
			myTxt.text="";
			tick_mc1.visible=false;
			myStage.stage.focus=myTxt;
			correctAngTxt=0;
		}
		private function showTxtFeedback(evt:MouseEvent) {
			findCurrAngTxt();
			resetAngTxt();
			//trace("correctAngTxt = "+correctAngTxt);
			angTxt.text=angTxtArr[evt.currentTarget.num-1];
			tick_mc2.visible=true;
			if (correctAngTxt==evt.currentTarget.num) {
				//evt.currentTarget.gotoAndStop("correct");
				
				tick_mc2.gotoAndStop(1);
				txtCor=1;
			} else {
				txtCor=0;
				//tick_mc2.visible=false;
				tick_mc2.gotoAndStop(2);
				//evt.currentTarget.gotoAndStop("wrong");
			}
			checkAnswers();
		}
		private function checkAnswers() {
			if (txtCor==1 && angCor==1) {
				feedback_mc.visible=false;
			} else {
				feedback_mc.visible=false;
			}
		}
		private function resetAngTxt() {
			for (var i=1; i<=5; i++) {
				myStage["angTxt" + i].gotoAndStop(1);
			}
			angTxt.text="";
			tick_mc2.visible=false;
		}
		private function findCurrAngTxt() {
			if (myAngle<90) {
				correctAngTxt=1;
			} else if (myAngle==90) {
				correctAngTxt=2;
			} else if (myAngle>90&&myAngle<180) {
				correctAngTxt=3;
			} else if (myAngle==180) {
				correctAngTxt=4;
			} else if (myAngle>180) {
				correctAngTxt=5;
			}
		}
		private function onDownArrow(evt:MouseEvent) {
			resetAngTxt();
			angCor=0;
			txtCor=0;
			feedback_mc.visible=false;
			myTxt.text="";
			tick_mc1.visible=false;
			myStage.stage.focus=myTxt;
			arrowLine.addEventListener(Event.ENTER_FRAME, onMovArrow);
			arrowLine.parent.stage.addEventListener(MouseEvent.MOUSE_UP, onUpArrow);
		}
		private function onUpArrow(evt:MouseEvent) {
			arrowLine.removeEventListener(Event.ENTER_FRAME, onMovArrow);
			arrowLine.parent.stage.removeEventListener(MouseEvent.MOUSE_UP, onUpArrow);
		}
		private function onMovArrow(evt:Event) {
			var distanceX : Number = myStage.mouseX - arrowLine.x;
			var distanceY : Number = myStage.mouseY - arrowLine.y;
			var angleInRadians : Number = Math.atan2(distanceY, distanceX);
			var andleInDegrees : Number = Math.round(angleInRadians * (180 / Math.PI));
			if ((andleInDegrees%5)!=0) {
				var multiplier=Math.round(andleInDegrees/5);
				andleInDegrees=multiplier*5;
			}
			if ((andleInDegrees%5)==0) {
				//trace("andleInDegrees = "+andleInDegrees);
				if (andleInDegrees<0) {
					andleInDegrees=-(andleInDegrees);
					myAngle=(andleInDegrees);
				} else {
					myAngle=(360-andleInDegrees);
				}
				//trace("myAngle = "+myAngle);
				arrowLine.rotation=(360-myAngle);
				if (myAngle==360) {
					myAngle=0;
				}
				if (myAngle>180) {
					protractor_mc.gotoAndStop(2);
				} else {
					protractor_mc.gotoAndStop(1);
				}
				drawCurve();
			}
		}
	}
}